#define WIN32_LEAN_AND_MEAN
#define WIN32_EXTRA_LEAN
#include <windows.h>

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>

// Debug stuff /////////////////////////////////////////////////////////////////////////////////////////////
static char pAssertFmt[] = "Debug Assertion Failed!\n\nExpression: %s\nFile: %s\nLine: %d\n\n(Press retry to debug the application)";
static char pErrorFmt[] = "Critical Program Alert!\n\n%s\n\nFile: %s\nLine: %d\n\n(Press okay to shut down the application)";

void W_Assert(char* pExpr, char* pFile, unsigned iLine)
{
	char pMsg[1024];
	FILE* f;

	_snprintf(pMsg, 1024, pAssertFmt, pExpr, pFile, iLine);
	f = fopen("debug.log", "at"); fprintf(f, "ASSERT: %s %s %d\n", pExpr, pFile, iLine); fclose(f);
	switch(MessageBox(NULL /*hwnd*/, pMsg /*text*/, NULL /*title*/, MB_ABORTRETRYIGNORE | MB_ICONSTOP | MB_SETFOREGROUND)) {
		case IDRETRY: __asm int 3;
		case IDABORT: exit(EXIT_FAILURE);
	}
}

void W_Message(char* fmt, ...)
{
	va_list arglist;
	char msgbuf[1024];
	FILE* f;

	va_start(arglist, fmt);
	_vsnprintf(msgbuf, 1024, fmt, arglist);
	va_end(arglist);

	OutputDebugStringA(msgbuf);
	f = fopen("debug.log", "at"); fputs(msgbuf, f); fclose(f);
}
