#ifndef __DEBUG_H
#define __DEBUG_H

void W_Assert(char* pExpr, char* pFile, unsigned iLine);
void W_Message(char* fmt, ...);

// Debug / Diagnostic stuff
#ifdef _DEBUG
	#define ASSERT(exp) (void)( (exp) || (W_Assert(#exp, __FILE__, __LINE__), 0) )
	#define VERIFY(exp) (void)( (exp) || (W_Assert(#exp, __FILE__, __LINE__), 0) )
	#define DUMP W_Message
	#define DUMPINT(x) W_Message(#x ": %d\n", x)
	#define DUMPHEX(x) W_Message(#x ": %x\n", x)
	#define DUMPFLT(x) W_Message(#x ": %f\n", x)
	#define DUMPPTR(x) W_Message(#x ": %08x\n", (ulong)x)
	#define DUMPSTR(x) W_Message(#x ": %s\n", x)
#else
	#define ASSERT(__ignored) (0)
	#define VERIFY(exp) (exp)
	#define DUMP (0)
	#define DUMPINT(__ignored) (0)
	#define DUMPHEX(__ignored) (0)
	#define DUMPPTR(__ignored) (0)
	#define DUMPSTR(__ignored) (0)
#endif
#define CHECK(exp,msg) (void)( (exp) || (W_Assert((msg), __FILE__, __LINE__), 0) )

#endif //__DEBUG_H